var styles_cytoscape = [{ "selector" : "core", "style"    : { "background-color" : "white"} },{ "selector" : "node", "style"    : { "shape": "rectangle"     , "display": "block"         , /*BACKGROUND*/ "background-width"         : "40px"          , "background-height"        : "40px"          , "background-position-x"    : "0px"           , "background-position-y"    : "0px"           , "background-fit"           : "contain"       , "width": 200             , "height": 40              , /*FONT*/ "color"                    : "#494949"       , "font-size"                : "1em"           , "text-wrap"                : "wrap"          , "text-valign"              : "center"        , "text-halign"              : "center"        , "min-zoomed-font-size"     : "0.3em"} },{ "selector" : "node:selected", "style"    : { "border-width"    : 6, "border-style"    : "solid", "border-color"    : "black", "font-weight"     : "bold"} },{ "selector" : "node.expert", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/expert.png)"} },{ "selector" : "node.usergroupcontact", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/user_group_contact.png)"} },{ "selector" : "node.usergroup", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/user_group.png)"} },{ "selector" : "node.expertgroup", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/expert_group.png)"} },{ "selector" : "node.rack", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/rack.png)"} },{ "selector" : "node.server", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/server.png)"} },{ "selector" : "node.blockdevice", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/block_device.png)"} },{ "selector" : "node.switch", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/switch.png)"} },{ "selector" : "node.networkinterface", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/network_interface.png)"} },{ "selector" : "node.configuration", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/configuration.png)"} },{ "selector" : "node.configurationgroup", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/configuration_group.png)"} },{ "selector" : "node.coregroup", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/core_group.png)"} },{ "selector" : "node.serviceelement", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/service_element.png)"} },{ "selector" : "node.dnsalias", "style"    : { "background-image"     : "url(/resource/rsc/images/node_class/dnsalias.png)"} },{ "selector" : "edge", "style"    : { "label": "data(label)", "edge-text-rotation"     : "none"       , "curve-style"            : "bezier"     , "line-style"             : "dotted"     , "source-arrow-shape"     : "none"       , "source-arrow-fill"      : "filled"     , "mid-source-arrow-shape" : "none"       , "target-arrow-shape"     : "triangle"   , "target-arrow-fill"      : "filled"     , "mid-target-arrow-shape" : "none"       , "z-index": 1} },{ "selector" : "edge[nodes]", "style"    : { "width": 4} },{ "selector" : ".rouge", "style"    : { "line-color"         : "#FF0000", "source-arrow-color" : "#FF0000", "target-arrow-color" : "#FF0000", "background-color"   : "#FF0000"} },{ "selector" : ".rouge_orange", "style"    : { "line-color"         : "#FF4D1A", "source-arrow-color" : "#FF4D1A", "target-arrow-color" : "#FF4D1A", "background-color"   : "#FF4D1A"} },{ "selector" : ".orange", "style"    : { "line-color"         : "#FF9933", "source-arrow-color" : "#FF9933", "target-arrow-color" : "#FF9933", "background-color"   : "#FF9933"} },{ "selector" : ".orange_jaune", "style"    : { "line-color"         : "#FFCC1A", "source-arrow-color" : "#FFCC1A", "target-arrow-color" : "#FFCC1A", "background-color"   : "#FFCC1A"} },{ "selector" : ".jaune", "style"    : { "line-color"         : "#FFFF00", "source-arrow-color" : "#FFFF00", "target-arrow-color" : "#FFFF00", "background-color"   : "#FFFF00"} },{ "selector" : ".vert", "style"    : { "line-color"         : "#00FF00", "source-arrow-color" : "#00FF00", "target-arrow-color" : "#00FF00", "background-color"   : "#00FF00"} },{ "selector" : ".cause", "style"    : { "line-style"         : "dotted"    , "opacity": "0.5"} },{ "selector" : "node.intersection", "style"    : { "line-style"         : "dotted"    , "opacity": "1"} },{ "selector" : ".impacter", "style"    : { "line-style"             : "solid"} },{ "selector" : ".external", "style"    : { "background-color"   : "#FFFFFF", "border-width"       : 1, "border-style"       : "dotted", "border-color"       : "lightgrey", "line-style"         : "dotted", "opacity": "1"} },{ "selector" : "$node > node", "style"    : { "shape": "roundrectangle"   , "label": "data(label)"      , /*BORDER*/ "border-color"         : "#00DDFF"          , "border-style"         : "solid"            , "border-width"         : 1                  , /*FONT*/ "font-size"            : "1.3em"            , "font-weight"          : "bold"             , "text-valign"          : "top"              , "text-halign"          : "center"           , "min-zoomed-font-size" : "0.7em"            , "opacity": 1} } ];

var ConvertXmlToJson = (function () { 'use strict'; /** @description Convertis un XML en JSON compatible cytoscape. @param {Element} xml The XML DOM object. @typedef ConvertXmlToJson Convertis un graphml en JSON. Nécessite un argument de type Element (DOM Element). */ function ConvertXmlToJson(xml) { /** @description Le XML passé en paramètre. @private */ var _xml = xml; /** @description Tableau contenant le JSON correspondant aux XML. @type Object @private */ var jsonObjectTableau = []; /** @description Donne le JSON. @returns {Object} */ this.getJSON = function () { return jsonObjectTableau; }; /** @description Donne le XML. @returns {Element} L'objet XML DOM brut. */ this.getXML = function () { return _xml; }; /** @description Récupère tous les 'node' du XML et les introduits dans le 'jsonObjectTableau'. */ function recuperationDesNodes() { $(_xml).find("*").filter(function () { /* Récupération de tous les éléments 'node' du XML. */ return this.nodeName.toLowerCase().match(/node$/) !== null; }).each(function () { /* Création de l'objet JSON à partir du l'élément XML actuellement en cours de parcours. Récupération de l'id et assignation d'un group. */ var jsonNodeObject = {data: {id: $(this).attr("id")}, group: elementGroup.node}; /* Altération de l'objet, par le biais d'une fonction, pour ajout des différentes 'data'. */ getNodeData($(this), jsonNodeObject); /* Ajout de l'objet dans le jsonObjectTableau. */ jsonObjectTableau.push(jsonNodeObject); }); } /** @description Récupère les différents paramètre du node passé en paramètre. @param {Element} node Les éléments node du XML. @param {Object} jsonNodeObject Les éléments node au format JSON compatible cytoscape. */ function getNodeData(node, jsonNodeObject) { $(node).find("*").filter(function () { /* Récupération de chaque élément 'data' du node. */ return this.nodeName.toLowerCase().match(/data$/) !== null; }).each(function () { /* Récupération de toutes les data du node sous forme de clé/valeur. Attribution du tous dans l'attribut data de l'objet JSON.  */ jsonNodeObject.data[($(this).attr("key").toLowerCase() === "label" ? "class" : $(this).attr("key").toLowerCase())] = ($(this).text() !== "" ? $(this).text() : undefined); /* Création d'une nouvelle propriété de l'objet jsonNodeObject qui correspond à l'attribut 'key' de data et ajout de sa valeur.*/ }); /* Ajout de l'attribut parent en préparation pour utilisation des groupes. Voir ElementJSON */ jsonNodeObject.data.parents = {}; } /** @description Récupère tous les 'edge' du XML et les introduits dans le 'jsonObjectTableau'. */ function recuperationDesEdges() { $(_xml).find("*").filter(function () { /* Récupération de tous les élément 'edge' du XML. */ return this.nodeName.toLowerCase().match(/edge$/) !== null; }).each(function () { /* Création de l'objet edge au format JSON. Récupération de la source et de la target de l'élément parcourut et assignation du group. */ var jsonEdgeObject = {data: {source: $(this).attr("source"), target: $(this).attr("target")}, group : elementGroup.edge}; /* Altération de l'objet, par le biais d'une fonction, pour ajout des data supplémentaires. */ getEdgeData($(this), jsonEdgeObject); /* Ajout de l'objet dans jsonObjectTableau */ jsonObjectTableau.push(jsonEdgeObject); }); }/** @description Récupère les différents paramètre du edge passé en paramètre. @param {Element} edge Les éléments edge du XML. @param {Object} jsonEdgeObject Les éléments edge au format JSON compatible cytoscape. */ function getEdgeData(edge, jsonEdgeObject) { $(edge).find("*").filter(function () { /* Récupération de tous les élément 'data' du edge. */ return this.nodeName.toLowerCase().match(/data$/) !== null; }).each(function () { /* Parcours de tous les éléments data du edge ; récupération de clé/valeur à partir de l'attribut 'key' et de la valeur du texte. */ jsonEdgeObject.data[$(this).attr("key").toLowerCase()] = ($(this).text() !== "" ? $(this).text() : undefined); }); } recuperationDesNodes(); recuperationDesEdges(); } return ConvertXmlToJson; }());

var IteratorGraph = (function () { 'use strict'; /** @description Crée un itérateur pour parcourir les éléments données. @param {Object|Array} element Eléments à parcourir. @typedef IteratorGraph Un itérateur capable de parcourir des Object|Array. */ function IteratorGraph (element) { /** @description Index utilisé pour le parcours des éléments. @type Number */ this.index = 0; /** @description Eléments à parcourir. Peut être un Object ou un Array. @type Object|Array */ var _element = element; /** @description Donne l'élément à l'index donné. @param index @returns {*} */ this.getElementAt = function (index) { if (_keys) return _element[_keys[index]]; else       return _element[index]; }; /** @description Donne la taille de _element. @returns {Number} */ this.size = function () { if (_keys) return _keys.length; else       return _element.length; }; /* Uniquement si l'objet à parcourir n'est pas un tableau. */ if (!_element.length) { /** @description Clé de l'objet à parcourir. @type Array<String> */ var _keys = Object.keys(_element); } } IteratorGraph.prototype = { /** @description Place l'index avant le premier élément. */ beforeFirst : function () { this.index = -1; }, /** @description Donne la première itération. @returns {Object|Array|String|Number} */ first: function () { this.reset(); return this.current(); }, /** @description Donne l'itération précédante. @returns {Object|Array|String|Number} */ previous : function () { return this.getElementAt(--this.index); }, /** @description Donne l'itération actuelle. @returns {Object|Array|String|Number} */ current : function () { return this.getElementAt(this.index); }, /** @description Donne la prochaine itération. @returns {Object|Array|String|Number} */ next: function () { return this.getElementAt(++this.index); }, /** @description Donne la dernière itération. @returns {String|Object|Number|Array} */ last: function () { this.index = this.size() - 1; return this.current(); }, /** @description Place l'index après le dernier élément. */ afterLast : function () { this.index = this.size(); }, /** @description Réinitialise l'itérateur à sa première itération. */ reset: function () { this.index = 0; }, /** @description Dit s'il y a encore au moins un élément avant le dernier que l'on a récupérer. @returns {boolean} */ hasPrevious : function () { return this.index > 0; }, /** @description Dit s'il y a encore au moins un élément après le dernier que l'on a récupérer. @returns {boolean} */ hasNext : function () { return this.index < this.size() - 1; }, /** @description Parcours tous les éléments en appelant callback pour chacun. @param {Function} callback @param {Function} [progressionCallback] Optionnel, appel de cette fonction fait tous les 1000 éléments. Give a percentage of accomplisshment each time it call. */ forEach : function (callback, progressionCallback) { var hasToCallProgressionCallback = progressionCallback && this.size() > 1000; this.beforeFirst(); do { callback(this.next()); if (hasToCallProgressionCallback && (this.index % 1000 === 0)) progressionCallback(this.index * 100 / this.size()); } while (this.hasNext()); } }; return IteratorGraph; }());

var StringIterator = (function () { 'use strict'; /** @description Create a StringIterator. @typedef StringIterator This gives you the possibility to navigate into strings. @param {String} string @param {String} [stringSeparator] Specify a character used to split the string. Default = " ". @constructor */ function StringIterator (string, stringSeparator) { stringSeparator = stringSeparator || " "; /** @description Contains all separated string. @type {Array<String>} @public */ this.string_arr = string.split(stringSeparator); /** @description The index of the string. @type {number} @public */ this.string_index = 0; } StringIterator.prototype = { /** @description Place the index before the first string. */ beforeFirst :  function () { this.string_index = -1; }, /** @description Give the first string. @returns {String} */ first: function () { return this.string_arr[(this.string_index = 0)]; }, /** @description Give the previous string. @returns {String} */ previous : function () { return this.string_arr[--this.string_index]; }, /** @description Give the current string. @returns {String} */ current : function () { return this.string_arr[this.string_index]; }, /** @description Give the next string. @returns {String} */ next: function () { return this.string_arr[++this.string_index]; }, /** @description Give the last string. @returns {String} */ last: function () { return this.string_arr[(this.string_index = this.string_arr.length - 1)]; }, /** @description Place the index after the last string. */ afterLast : function () { this.string_index = this.string_arr.length; }, /** @description Tell if it has previous strings. @returns {boolean} */ hasPrevious : function () { return this.string_index > 0; }, /** @description Tell if it has next strings. @returns {boolean} */ hasNext : function () { return this.string_index < this.string_arr.length - 1; }, /** @description Do something for each string it has. @param {Function} callback Function you want to call for each strings @param {Function} [progressionCallback] Function is called each 100 iterations. */ forEach : function (callback, progressionCallback) { var hasToCallProgressionCallback = (progressionCallback && this.string_arr.length > 100); this.beforeFirst(); do { callback(this.next()); if (hasToCallProgressionCallback && (this.string_index % 100 === 0)) progressionCallback(this.string_index * 100 / this.string_arr.length); } while (this.hasNext()); } }; return StringIterator; }());

var VizElement = (function () { 'use strict'; /** @description Create a VizElement. @typedef VizElement Object used to configure Viz @param {{width:Number, height:Number, direction:String, nodeShape:String, engine:String, format:String, dotElement:String}} [configObject] Configuration object. @constructor */ function VizElement (configObject) { /** @description Desired width of the graph. @type Number @private */ var _width       = configObject.width || undefined; /** @description Desired height of the graph. @type Number @private */ var _height      = configObject.height || undefined; /** @description Direction of graph layout: - LR => Left-Right, - RL => Right-Left, - TB => Top-Bottom, - BT => Bottom-Top. @type String @private */ var _direction   = configObject.direction || undefined; /** @description Shape of the nodes: - box, rect, rectangle, square, parallelogram, trapezium, invtrapezium, Msquare - ellipse, oval, circle, point, egg, doublecircle, Mcircle - polygon, triangle, diamond, house, pentagon, hexagon, septagon, octagon, doubleoctagon, tripleoctagone, invtriangle, invhouse - plaintext, plain, note, tab, folder, box3d, component, signature, star, none, underline, promoter, cds, terminator, utr, primersite, restrictionsite, fivepoverhang, threepoverhang, noverhang, assembly, insulator, ribosite, rnastab, proteasesite, proteinstab, rpromoter, rarrow, larrow, lpromoter @type String @private */ var _node_shape  = configObject.nodeShape || undefined; /** @description Engine used by Viz - layout for the graph: - circo, dot, neato, osage, patchwork, twopi, fdp @type String @private */ var _engine      = configObject.engine || "neato"; /** @description The format to export the data. @type {String} @private */ var _format      = configObject.format || "plain"; /** @description This is the graph content. @type {String} @private */ var _dot_element = configObject.dotElement || ""; /** @description Contains the Viz(...) result. @type Viz @private */ var _viz; /** @description Contains the graph sizes and the positions and sizes of each nodes. @type {{graph:{width:Number, height:Number, scale:Number}, nodes:{node_Id:{width:Number, height:Number, x:Number, y:Number}}}|null} @private */ var _position = null; /** @description Set up the desired size of the graph. @param {Number} width @param {Number} height */ this.setSize = function (width, height) { _width = width ; _height = height; }; /** @description Give the desired size of the graph. @returns {{width:Number, height:Number}} */ this.getSize = function () { return {width: _width, height : _height}; }; /** @description Set up the direction of the graph layout. @param {String} direction */ this.setDirection = function (direction) { _direction = direction; }; /** @description Give the direction of the graph layout. @returns {String} */ this.getDirection = function () { return _direction;}; /** @description Set up the node's shape. @param {String} nodeShape */ this.setNodeShape = function (nodeShape) { _node_shape = nodeShape; }; /** @description Give the node's shape. @returns {String} */ this.getNodeShape = function () { return _node_shape; }; /** @description Set up the graph engine (this is the layout to use). @param {String} engine */ this.setEngine = function (engine) { _engine = engine; }; /** @description Give the graph engine (this is the layout to use). @returns {String} */ this.getEngine = function () { return _engine; }; /** @description Set up the format to export the data. @param format */ this.setFormat = function (format) { _format = format; }; /** @description Give the format of the exported data. @returns {String} */ this.getFormat = function () { return _format; }; /** @description Set up the graph content. @param {String} dotElement */ this.setElement = function (dotElement) { _dot_element = dotElement; }; /** @description Give the graph content. @returns {String} */ this.getElement = function () { return _dot_element; }; /** @description Give the graph sizes and the positions and sizes of each nodes. @returns {{graph: {width: Number, height: Number, scale: Number}, nodes: {node_Id: {width: Number, height: Number, x: Number, y: Number}}}} */ this.getPosition = function () { if (_position === null) { takePosition(); } return _position; }; /** @description Call Viz(...) with the configuration already specified. */ this.run = function () { _viz = Viz(getCompleteGraph(), {format:_format, engine:_engine}); _position = null; }; /** @description Give the complete dot graph with the configuration. digraph G { [global options] list of nodes list of edges } @returns {String} */ function getCompleteGraph () { var dotGraphe = "digraph G {\n"; if (_width || _height) { if (_width && _height)  dotGraphe += "size = \"" + _height + "," + _width + "\";\n"; else                    dotGraphe += "size = \"" + (_width || _height) + "\";\n"; } if (compatibleDirectedLayout.indexOf(_engine) !== -1 && _direction) dotGraphe += "rankdir = " + _direction + ";\n"; if (_node_shape) dotGraphe += "node[shape=" + _node_shape + "];\n"; dotGraphe += _dot_element; dotGraphe += "}"; return dotGraphe; } /** @description Tell if this line is a graph's line. @param {String} type @returns {boolean} */ function isGraph (type) { return type === "graph"; } /** @description Tell if this line is a node's line. @param {String} type @returns {boolean} */ function isNode (type) { return type === "node"; } /** @description Tell if this line is a edge's line. @param {String} type @returns {boolean} */ function isEdge (type) { return type === "edge"; } /** @description Take the positions and sizes of each nodes. Must be called after the first this.run(). */ function takePosition () { _position = {graph:{}, nodes:{}}; new StringIterator(_viz, "\n").forEach(function (line) { var wordIterator = new StringIterator(line); var type = wordIterator.first(); if (isGraph(type)) { var insertIntoAttribute = {1:"scale", 2:"width", 3:"height"}; for (var i = 1, word = wordIterator.next() ; i <= 3 ; i++, word = wordIterator.next()) { _position.graph[insertIntoAttribute[i]] = word; } } else if (isNode(type)) { var insertIntoAttribute = {2:"x", 3:"y", 4:"width", 5:"height"}; var node_id = wordIterator.next(); _position.nodes[node_id] = {}; for (var i = 2, word = wordIterator.next() ; i <= 5 ; i++ , word = wordIterator.next()) { _position.nodes[node_id][insertIntoAttribute[i]] = word; } } }, function (percentage) { console.log("Getting positions. " + percentage + "% completed."); }); } } return VizElement; }());

var ElementJSON = (function () {
    'use strict';
    /**
     * @description Contient les éléments pour cytoscape. Elément d'origine, groupé, filtré et communique avec VizElement pour récupérer la position de tous les nodes (lors de demande de layout graphviz par l'utilisateur).
     * @param {Array<Object>} jsonObjectTableau Tableau d'objet JSON compatible cytoscape.
     * @typedef ElementJSON Contient tous les éléments au format JSON compatible avec cytoscape et fait toutes les modifications de ces éléments.
     */
    function ElementJSON(jsonObjectTableau) {
        /*      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      PROPRIETES      */
        /**
         * @description Contient tous les json qui seront utilisé, sous forme groupé, filtré ou original.
         * @type {{origine:Object, groupbycause:Object, groupbyimpact:Object, filtre:Object, toArray:Function}}
         */
        var json = {
            origine: undefined,
            groupbycause: undefined,
            groupbyimpact: undefined,
            filtre: null,
            toArray: function (jsonToUse) {
                return $.map(jsonToUse.nodes, function (element) {
                    return element;
                }).concat($.map(jsonToUse.groups, function (element) {
                    return element;
                }).concat($.map(jsonToUse.edges, function (element) {
                    return element;
                })));
            }
        };
        /**
         * @description Informe sur le json utilisé.
         * @type String
         */
        var used = utilisation.origine;
        /**
         * @description Contient les rÃƒÂ©fÃƒÂ©rences vers les nodes root du graphe.
         * @type Array of JSON Node Object
         */
        var rootsNode = [];
        /**
         * @description Utilisation de VizElement pour avoir les positions des nodes.
         * VizElement va créer un graphe en utilisant graphviz (version javascript : viz.js) qui va calculé la position des nodes.
         * @type VizElement
         */
        var viz_element;
        /*      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      ACCESSEURS      */
        /**
         * @description Donne l'utilisation non filtré du JSON.
         * @returns {String}
         */
        this.getUsed = function () { return used; };
        /**
         * @description Donne les nodes root (qui n'ont pas de prédécesseur ; groupe non compris).
         * @returns {Array<Object>|ElementJSON.rootsNode}
         */
        this.getRoots = function () { return rootsNode; };
        /**
         * @description Donne le JSON d'origine sous forme de tableau.
         * @returns {Array<Object>|ElementJSON.json.origine}
         */
        this.getElementOrigine = function () { return getElementBy(utilisation.origine); };
        /**
         * @description Donne le JSON groupé par cause sous forme de tableau.
         * @returns {Array<Object>|ElementJSON.json.groupbycause}
         */
        this.getElementByCause = function () { return getElementBy(utilisation.cause); };
        /**
         * @description Donne le JSON groupé par impact sous forme de tableau.
         * @returns {Array<Object>|ElementJSON.json.groupbyimpact}
         */
        this.getElementByImpact = function () { return getElementBy(utilisation.impact); };
        /**
         * @description Donne le JSON, sous forme de tableau, une foi filtré.
         * @param {Array} valArray Tableau de label pour filtre.
         * @returns {Array<Object>|ElementJSON.json.filtre}
         */
        this.getFilteredElement = function (valArray) {
            if (valArray !== undefined) {
                json.filtre = {nodes: copyOfJson(json[used].nodes), edges: copyOfJson(json[used].edges), groups: copyOfJson(json[used].groups)};
                filtre(valArray);
            }
            return json.toArray(json.filtre);
        };
        /**
         * @description Donne le JSON utilisé sans prendre en compte le JSON filtré.
         * @returns {Array.<Object>|ElementJSON.json.origine|ElementJSON.json.groupbycause|ElementJSON.json.groupbyimpact}
         */
        this.getUsedJson = function () { return getElementBy(); };
        /**
         * @description Donne les éléments pour l'utilisation demandé.
         * @param {Utilisation} groupe_wanted Enumération utilisation.
         */
        this.getElementFor = function (groupe_wanted) { return getElementBy(groupe_wanted); };
        /**
         * @description Donne le JSON correspondant au groupement demandé sous forme de tableau.
         * @param [groupement] Groupement souhaité. Par défaut correspond à l'utilisation en cours 'used'.
         * @returns {Array<Object>|ElementJSON.json.origine|ElementJSON.json.groupbycause|ElementJSON.json.groupbyimpact|null}
         */
        function getElementBy (groupement) {
            groupement = groupement || used;
            switch (groupement) {
                case utilisation.origine:
                    /* Si l'utilisation est différente de celle d'origine alors les éléments sont groupé. On enlève donc tous les parent de chaque node. */
                    if (used !== utilisation.origine)
                        new IteratorGraph(json.origine.nodes).forEach(function (node) {
                            delete node.data.parent
                        }, function (percentage) {console.log("Deleting nodes parents. " + percentage + "% completed.");});
                    break;
                case utilisation.cause:
                case utilisation.impact:
                    /* Si le json groupé existe alors ses groupes sont déjà connu et stocké dans une variable.
                     Au lieu de refaire tout les groupes, on mets juste à jours les nodes avec les informations que l'on a déjà. */
                    if(!json[groupement]) createJsonGroupBy(groupement);
                    else                  updateParent(groupement);
                    break;
                default:
                    return null;
            }
            /* S'il y avait un filtre, il n'est plus d'actualité donc on l'enlève. */
            if (json.filtre) json.filtre = null;
            /* Mise à jours de l'utilisation puis retour du json demandé. */
            used = groupement;
            return json.toArray(json[used]);
        }
        /**
         * @description Donne le JSON actuellement utilisé (tiens compte du filtre).
         * @returns {{nodes:Object, edges:Array<Object>: groups:Array<Object>}|ElementJSON.json.origine|ElementJSON.json.groupbycause|ElementJSON.json.groupbyimpact|ElementJSON.json.filtre|null}
         */
        function getJsonToUse() {
            var jsonToUse;
            if (!json.filtre) {
                switch (used) {
                    case utilisation.origine:
                        jsonToUse = json.origine;
                        break;
                    case utilisation.cause:
                    case utilisation.impact:
                        jsonToUse = json[used];
                        break;
                    default:
                        jsonToUse = null;
                        break;
                }
            } else {
                jsonToUse = json.filtre;
            }
            return jsonToUse;
        }
        /**
         * @description Donne toutes les class du json sous forme de tableau.
         * @returns {Array<String>}
         */
        this.getClasses = function () {
            var classes = [];
            new IteratorGraph(json.origine.nodes).forEach(function (node) {
                if (classes.indexOf(node.data.class) === -1)
                    classes.push(node.data.class);
            }, function(percentage) {console.log("Get all the nodes' classes. " + percentage + "% completed.");});
            return classes;
        };
        /**
         * @description Donne les informations utilisé par viz_element pour définir le layout utilisé.
         * @returns {{nom:String, direction:String}}
         */
        this.getVizLayout = function () {
            return {nom: viz_element.getEngine(), direction: viz_element.getDirection()};
        };

        /*      INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        INITIALISEUR        */
        /**
         * @description Initialisation complète du json.
         */
        function initJsonElement() {
            var elements_a_chainer = preparation_des_elements_pour_chainage();
            chainage_des_elements(elements_a_chainer);
            initialisation_du_json();
            initViz();
        }
        /**
         * @description Préparation des éléments en vue d'un future chainage.
         * @returns {Object}
         */
        function preparation_des_elements_pour_chainage() {
            var future_chainage_object = {};
            /* Il est possible qu'il y ait par défaut des nodes sélectionné.
             Ceux ci ne le savent pas, l'information est donné par le xsl dans les variables 'myClass', 'myKey', 'myValue'. */
            var regEx, preselected_function;
            if (myClass !== undefined && myKey !== undefined && myValue !== undefined) {
                regEx = new RegExp(myValue);
                if (myClass !== '*') {
                    preselected_function = isPreselectedNode_WithClass;
                } else {
                    preselected_function = isPreselectedNode_WithoutClass;
                }
            }

            /*Préparation des éléments en vue du chainage.*/
            new IteratorGraph(jsonObjectTableau).forEach(function (element) {
                if (isNode(element)) {
                    /*Ajout du node au tableau pour future chainage.*/
                    if (future_chainage_object[element.data.id])
                        future_chainage_object[element.data.id].himself = element;
                    else
                        future_chainage_object[element.data.id] = {himself: element};

                    /*Ajout de la class du node dans attribut classes.*/
                    element.classes = element.data.class.toLowerCase();

                    /*Préselection du node s'il répond au critère.*/
                    if (preselected_function) preselected_function(element, regEx);
                } else if (isEdge(element)) {
                    /*Récupération de l'id du node source.*/
                    var id_node_source = element.data.source;
                    /*Récupération de l'id du node target.*/
                    var id_node_target = element.data.target;

                    /*Ajout edge en tant que suivant du node source.*/
                    if (future_chainage_object[id_node_source]) {
                        if (future_chainage_object[id_node_source].edges) {
                            future_chainage_object[id_node_source].edges.suivants.push(element);
                        } else {
                            future_chainage_object[id_node_source].edges = {suivants: [element], precedants: []};
                        }
                    } else {
                        future_chainage_object[id_node_source] = {edges: {suivants: [element], precedants: []}};
                    }
                    /*Ajout edge en tant que précédant du node target.*/
                    if (future_chainage_object[id_node_target]) {
                        if (future_chainage_object[id_node_target].edges) {
                            future_chainage_object[id_node_target].edges.precedants.push(element);
                        } else {
                            future_chainage_object[id_node_target].edges = {suivants: [], precedants: [element]};
                        }
                    } else {
                        future_chainage_object[id_node_target] = {edges: {suivants: [], precedants: [element]}};
                    }
                }
            }, function (percentage) {
                console.log("Préparation des éléments en vue du chainage. " + percentage + "% terminer.");
            });

            return future_chainage_object;
        }
        /**
         * @description Fonction de préselection du node lorsque les paramètres donnés lors de la transformation XSL contiennent une classe valid.
         * @param {Object} node
         * @param {RegExp} regEx
         */
        function isPreselectedNode_WithClass(node, regEx) {
            if (node.data.class === myClass && regEx.exec(node.data[myKey.toLowerCase()]) !== null)
                node.data.selectionner = "selected";
        }
        /**
         * @description Fonction de préselection du node lorsque les paramètres donnés lors de la transformation XSL ne contiennent pas de classe valid.
         * @param {Object} node
         * @param {RegExp} regEx
         */
        function isPreselectedNode_WithoutClass(node, regEx) {
            if (regEx.exec(node.data[myKey.toLowerCase()]) !== null)
                node.data.selectionner = "selected";
        }
        /**
         * @description Chainage des éléments données.
         * @param {Object} elements_a_chainer
         */
        function chainage_des_elements(elements_a_chainer) {
            /*Récupération du node pour chainage.*/
            new IteratorGraph(elements_a_chainer).forEach(function (element) {
                var node = element.himself;

                /*Ajout des edges précédants s'il y en a.*/
                if (element.edges.precedants.length > 0) {
                    node.edgeAvant = element.edges.precedants;
                    /*Ajout du node en tant que target de chaque edges.*/
                    for (var e = 0; e < node.edgeAvant.length; e++) {
                        node.edgeAvant[e].nodeApres = node;
                    }
                } else {
                    /*Un node qui ne possède pas de edgeAvant lui est un node root.*/
                    rootsNode.push(node);
                }

                /*Ajout des edges suivants s'il y en a.*/
                if (element.edges.suivants.length > 0) {
                    node.edgeApres = element.edges.suivants;
                    /*Ajout du node en tant que source de chaque edges.*/
                    for (var e = 0; e < node.edgeApres.length; e++) {
                        node.edgeApres[e].nodeAvant = node;
                    }
                }
            }, function (percentage) {
                console.log("Chainage des éléments. " + percentage + "% terminer.");
            });
        }
        /**
         * @description Initialise le json.origine à partir des informations préalablement préparer.
         */
        function initialisation_du_json() {
            json.origine = {nodes: {}, edges: [], groups: []};
            remplissage_recursif_du_json(rootsNode);
        }
        /**
         * @description Rempli json.origine avec toutes les informations connues.
         * @param {Object|Array<Object>} nodes_to_add
         * @param {Number} [lvl] Prend la valeur 1 par défaut.
         */
        function remplissage_recursif_du_json(nodes_to_add, lvl) {
            /*Initialisation du lvl s'il n'existe pas.*/
            lvl = lvl || 1;
            /*Préparation d'un tableau de tous les nodes qui suivent.*/
            var nodes_suivant = [];

            /*Distinction de fonction dans le cas ou nodes_to_add est un tableau ou un objet.*/
            if (nodes_to_add.length) {
                nodes_suivant = remplissage_recursif_du_json_depuis_un_tableau(nodes_to_add, lvl);
            } else {
                nodes_suivant = remplissage_recursif_du_json_depuis_un_object(nodes_to_add, lvl);
            }
            /*S'il y a des nodes après ceux que l'on vient de traité, on repars pour un tour pour les ajoutés.*/
            if (nodes_suivant.length > 0) remplissage_recursif_du_json(nodes_suivant, ++lvl);
        }
        /**
         * @description Ajoute les informations de chaque node contenu dans le tableau dans json.origine .
         * @param {Array<Object>} array_of_node
         * @param {Number} lvl
         * @returns {Array}
         */
        function remplissage_recursif_du_json_depuis_un_tableau(array_of_node, lvl) {
            var nodes_suivant = [];
            for (var n = 0; n < array_of_node.length; n++)
                nodes_suivant = nodes_suivant.concat(remplissage_recursif_du_json_depuis_un_object(array_of_node[n], lvl));
            return nodes_suivant;
        }
        /**
         * @description Ajout les informations du node dans json.origine .
         * @param {Object} node
         * @param {Number} lvl
         * @returns {Array<Object>|[]}
         */
        function remplissage_recursif_du_json_depuis_un_object(node, lvl) {
            /*Ajout du lvl au node.*/
            node.data.lvl = lvl;

            /*Ajout du node dans json.origine.nodes*/
            if (!json.origine.nodes[node.data.id]) {
                json.origine.nodes[node.data.id] = node;

                /*Vérification que ce node à un node suivant.*/
                if (hasEdgeSuccesseurs(node)) {
                    json.origine.edges = json.origine.edges.concat(node.edgeApres);
                    return getNodesSuccesseurs(node);
                }
            }

            return [];
        }
        /*      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      VIZ ELEMENT      */
        /**
         * @description Initialise Viz.js pour utilisation de layout basé sur GraphViz.
         */
        function initViz() {
            /**
             * @description Give the number of 'inch' that is equal to the number of pixel given.
             * @param {number} pixel
             * @returns {number}
             */
            function pixel2inch(pixel) {
                /*1 pixel = 0.010416667 inch*/
                return pixel * 0.010416667;
            }

            viz_element = new VizElement({
                width: pixel2inch(window.innerWidth || document.documentElement.clientWidth || document.getElementsByTagName('body')[0].clientWidth),
                height: pixel2inch(window.innerHeight || document.documentElement.clientHeight || document.getElementsByTagName('body')[0].clientHeight),
                direction: "LR",
                nodeShape: "box"
            });
        }
        /**
         * @description Crée une chaine de caractère corrspondant à un format dot pour Viz.js
         * @returns {String}
         */
        function createDotForViz() {
            var reponse = "";
            var jsonToUse = getJsonToUse();

            new IteratorGraph(jsonToUse.nodes).forEach(function (node) {
                if (node.data.parent)   reponse += "subgraph \"cluster_" + node.data.parent + "\" {\"" + node.data.id + "\";}\n";
                else                    reponse += "\"" + node.data.id + "\";\n";
            }, function (percentage) {
                console.log("Creating dot nodes for viz element. " + percentage + "% completed.");
            });
            new IteratorGraph(jsonToUse.edges).forEach(function (edge) {
                reponse += "\"" + edge.data.source + "\" -> \"" + edge.data.target + "\";\n";
            }, function (percentage) {
                console.log("Creating dot edges for viz element. " + percentage + "% completed.");
            });

            return reponse;
        }
        /**
         * @description Mets à jours la position des nodes en utilisant VizElement.
         * @see VizElement
         */
        function majNodePositionFromViz() {
            /**
             * @description Give the number of 'pixel' that is equel to the number of inch given.
             * @param {number} inch
             * @returns {number}
             */
            function inch2pixel(inch) {
                /*1 inch = 96 pixel*/
                return inch * 96;
            }
            var width = window.innerWidth || document.documentElement.clientWidth || document.getElementsByTagName('body')[0].clientWidth
                , height = window.innerHeight || document.documentElement.clientHeight || document.getElementsByTagName('body')[0].clientHeight;
            var position = viz_element.getPosition();

            new IteratorGraph(getJsonToUse().nodes).forEach(function (node) {
                var nodeId = node.data.id;
                if (position.nodes[nodeId]) {
                    node.data.width = position.nodes[nodeId].width;
                    node.data.height = position.nodes[nodeId].height;
                    node.position = {
                        x: (width * inch2pixel(position.nodes[nodeId].x) / inch2pixel(position.graph.width) ),
                        y: (height * inch2pixel(position.nodes[nodeId].y) / inch2pixel(position.graph.height) )
                    };
                    /*node.data.personnalPosition = {x: (width * position.nodes[nodeId].position.x / position.graph.width )
                     , y: (height * position.nodes[nodeId].position.y / position.graph.height )};*/
                }
            }, function (percentage) {
                console.log("Updating nodes position from viz. " + percentage + "% completed.");
            });
        }
        /**
         * Modifie le moteur de viz et mets à jours les positions des nodes.
         * @param {String} engine
         * @see VizElement
         */
        this.changeVizEngine = function (engine) { viz_element.setEngine(engine); };
        /**
         * @description Modifie la direction du graphe.
         * @param {String} wanted_direction
         * @see VizElement
         */
        this.changeVizDirection = function (wanted_direction) { viz_element.setDirection(wanted_direction); };
        /**
         * @description Exécute le Viz tel que paramétré puis mets à jours la position des node.
         */
        this.runViz = function () {
            /*Donne à VizElement son graphe sous forme de String.*/
            viz_element.setElement(createDotForViz());
            viz_element.run();
            /*Modifie la position des nodes avec les données récupérer de VizElement.*/
            majNodePositionFromViz();
            /*Retourne le résultat sous forme de tableau.*/
            return json.toArray(getJsonToUse());
        };
        /*      TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        TESTEURS        */
        /**
         * @description Dit si l'objet JSON est un node.
         * @param {Object} element
         * @returns {Boolean}
         */
        function isNode(element) { return element.group === elementGroup.node; }
        /**
         * @description Dit si l'objet JSON est un edge.
         * @param {Object} element
         * @returns {Boolean}
         */
        function isEdge(element) { return element.group === elementGroup.edge; }
        /**
         * @description Dit si le json à été filtré.
         * @returns {Boolean}
         */
        this.isFilterJson = function () { return json.filtre !== null; };
        /*      UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     UTILITAIRES     */
        /**
         * @description Cré une copie du JSON.
         * Recupere la reference de toutes ses valeurs si celle-ci ne sont pas des types primitifs.
         * @param {Object|Array} json
         * @return {Object|Array}
         */
        function copyOfJson(json) {
            var copy = (json.length ? [] : {});
            $.each(json, function (index, item) { copy[index] = item; });
            return copy;
        }
        /**
         * @description Cree une copie récursive de l'element donne.
         * Cette copie cré de nouveau objet en copiant l'élément.
         * @param {Array|Object|null} element
         * @returns {Array|Object|null}
         */
        function copyOf(element) {
            if (element !== null) {
                var copy = (!element.length ? {} : []);

                $.each(element, function (index, item) {
                    if (typeof item !== "object")  copy[index] = item;
                    else                           copy[index] = copyOf(item);
                });

                return copy;
            } else {
                return element;
            }
        }
        /**
         * @description Donne le tableau passé en arguments sans les possible doublon qu'il contient.
         * @param {Array} tableau
         * @returns {Array}
         */
        function getArrayWithoutDuplicateValue(tableau) {
            return tableau.filter(function (value, index, array) {
                return array.lastIndexOf(value) === index;
            });
        }
        /**
         * @description Détermine si deux éléments sont identiques.
         * @param {Object} element1
         * @param {Object} element2
         * @returns {Boolean}
         */
        function elementIdentique(element1, element2) {
            if (isNode(element1)) {
                if (isNode(element2)) {
                    return nodeEstIdentique(element1, element2);
                } else {
                    return false;
                }
            } else {
                if (isEdge(element2)) {
                    return edgeEstIdentique(element1, element2);
                } else {
                    return false;
                }
            }
        }
        /**
         * @description Détermine si deux nodes sont identique.
         * Deux nodes sont dit identique si leur 'data.id' sont identique.
         * @param {Object} node1
         * @param {Object} node2
         * @returns {Boolean}
         */
        function nodeEstIdentique(node1, node2) { return node1.data.id === node2.data.id; }
        /**
         * @description Détermine si deux edges sont identique.
         * Deux edges sont dit identique si leurs 'data.source' et leurs 'data.target' est identique.
         * @param {Object} edge1
         * @param {Object} edge2
         * @returns {Boolean}
         */
        function edgeEstIdentique(edge1, edge2) { return ((edge1.data.source === edge2.data.source) && (edge1.data.target === edge2.data.target)); }
        /*      RECUPERATION ELEMENT JSON TABLEAU       RECUPERATION ELEMENT JSON TABLEAU       RECUPERATION ELEMENT JSON TABLEAU       RECUPERATION ELEMENT JSON TABLEAU       RECUPERATION ELEMENT JSON TABLEAU       RECUPERATION ELEMENT JSON TABLEAU       */
        /**
         * @description Donne le node source du edge.
         * @param {Object} edge
         * @param {Array<Object>} [jsonToUse]
         * @returns {Object}
         */
        function source(edge, jsonToUse) {
            var node = null;
            if (!edge.nodeAvant || jsonToUse) {
                if (jsonToUse) {
                    $.each(jsonToUse, function (index, element) {
                        if (isNode(element) && (edge.data.source === element.data.id)) {
                            node = element;
                            return;
                        }
                    });
                }
            } else {
                node = edge.nodeAvant;
            }
            return node;
        }
        /**
         * @description Donne le node target du edge.
         * @param {Object} edge
         * @param {Array<Object>} [jsonToUse]
         * @returns {Object}
         */
        function target(edge, jsonToUse) {
            var node = null;
            if (!edge.nodeApres || jsonToUse) {
                if (jsonToUse) {
                    $.each(jsonToUse, function (index, element) {
                        if (isNode(element) && (edge.data.target === element.data.id)) {
                            node = element;
                            return;
                        }
                    });
                }
            } else {
                node = edge.nodeApres;
            }
            return node;
        }
        /**
         * @description Renvoie tous les edges successeurs du node donnÃƒÂ©e.
         * @param {Object} node
         * @param {Array<Object>} [jsonToUse]
         * @returns {Array<Object>}
         */
        function getEdgesSuccesseur(node, jsonToUse) {
            var edgeTab = [];
            if (!node.edgeApres || jsonToUse) {
                if (jsonToUse) {
                    $.each(jsonToUse, function () {
                        if (isEdge(this) && this.data.source === node.data.id) {
                            edgeTab.push(this);
                        }
                    });
                }
            } else {
                edgeTab = node.edgeApres;
            }
            return edgeTab;
        }
        /**
         * @description Renvoie tous les edges predecesseur du node donnÃƒÂ©e.
         * @param {Object} node
         * @param {Array<Object>} [jsonToUse]
         * @returns {Array<Object>}
         */
        function getEdgesPredecesseur(node, jsonToUse) {
            var edgeTab = [];
            if (!node.edgeAvant || jsonToUse) {
                if (jsonToUse) {
                    $.each(jsonToUse, function () {
                        if (isEdge(this) && this.data.target === node.data.id) {
                            edgeTab.push(this);
                        }
                    });
                }
            } else {
                edgeTab = node.edgeAvant;
            }
            return edgeTab;
        }
        /**
         * @description Dit si le node donnée à  au moins un edge dont il est source.
         * @param {Object} node
         * @param {Array<Object>} [jsonToUse]
         * @returns {Boolean}
         */
        function hasEdgeSuccesseurs(node, jsonToUse) {
            var reponse = false;
            if (!node.edgeApres || jsonToUse) {
                if (jsonToUse) {
                    $.each(jsonToUse, function () {
                        if (isEdge(this) && this.data.source === node.data.id) {
                            reponse = true;
                            return;
                        }
                    });
                }
            } else {
                reponse = node.edgeApres.length > 0;
            }
            return reponse;
        }
        /**
         * @description Dit si le node donnée à  au moins un edge dont il est target.
         * @param {Object} node
         * @param {Array<Object>} [jsonToUse]
         * @returns {Boolean}
         */
        function hasEdgePredecesseurs(node, jsonToUse) {
            var reponse = false;
            if (!node.edgeAvant || jsonToUse) {
                if (jsonToUse) {
                    $.each(jsonToUse, function () {
                        if (isEdge(this) && this.data.target === node.data.id) {
                            reponse = true;
                            return;
                        }
                    });
                }
            } else {
                reponse = node.edgeAvant.length > 0;
            }
            return reponse;
        }
        /**
         * @descsr Donne tous les nodes qui sont directement successeur du node donné.
         * @param {Object} node Le node dont on veut les successeurs.
         * @param {Array<Object>} [jsonToUse]  Le json à  parcourir le cas échéant.
         * @returns {Array<Object>|[]} Tableau contenant la référence vers tous les nodes directement successeur du node donné
         */
        function getNodesSuccesseurs(node, jsonToUse) {
            var edgeSuccesseurs = getEdgesSuccesseur(node, jsonToUse);
            var nodeTab = [];
            $.each(edgeSuccesseurs, function (index) {
                if (!edgeSuccesseurs[index].nodeApres || jsonToUse) {
                    if (jsonToUse) {
                        $.each(jsonToUse, function () {
                            if (isNode(this) && this.data.id === edgeSuccesseurs[index].data.target) {
                                nodeTab.push(this);
                            }
                        });
                    }
                } else {
                    nodeTab.push(edgeSuccesseurs[index].nodeApres);
                }
            });
            return nodeTab;
        }
        /**
         * @description Récupère les nodes donné depuis 'json.origine'.
         * @param {Object} nodes
         * @param {Array<Object>|Object} [jsonToUse] Le json à  parcourir le cas échéant
         * @returns {Array<Object>|[]}
         */
        function getNodeFromJSON(nodes, jsonToUse) {
            var nodesReponse = [];

            if (!nodes.length) { nodes = [nodes]; }

            $.each(nodes, function (index, node) {
                var _node;
                if (jsonToUse)
                    $.each(jsonToUse, function (index, element) {
                        if (isNode(element) && nodeEstIdentique(node, element)) {
                            _node = element;
                            return;
                        }
                    });
                else _node = json.origine.nodes[node.id()];
                if (_node) nodesReponse.push(_node);
            });

            return nodesReponse;
        }
        /**
         * @description Donne tous les nodes dont le lvl est egale à 'lvl'.
         * @param {Number} lvl
         * @param {Array<Object>|Object} [jsonToUse] Le json à parcourir le cas échéant
         * @returns {Array<Object>|[]}
         */
        function getNodesLvl(lvl, jsonToUse) {
            var nodes_reponse = [];

            if (!jsonToUse.nodes) {
                $.each(jsonToUse, function (element) {
                    if (isNode(element) && element.data.lvl === lvl) {
                        nodes_reponse.push(element);
                    }
                });
            } else {
                new IteratorGraph((jsonToUse ? jsonToUse.nodes : json.origine.nodes)).forEach(function (node) {
                    if (node.data.lvl === lvl) nodes_reponse.push(node);
                }, function (percentage) { console.log("Getting the nodes of level " + lvl + ". " + percentage + "% completed."); });
            }

            return nodes_reponse;
        }
        /**
         * @description Donne tous les nodes dont le lvl est egale à 'lvl' + 1.
         * @param {Number} lvl
         * @param {Array<Object>} [jsonToUse] Le json à parcourir le cas échéant
         * @returns {Array}
         */
        function getNodesNextLvl(lvl, jsonToUse) { return getNodesLvl(lvl + 1, jsonToUse); }
        /*      MISE A JOURS AVAILABILITY NODE       MISE A JOURS AVAILABILITY NODE       MISE A JOURS AVAILABILITY NODE       MISE A JOURS AVAILABILITY NODE       MISE A JOURS AVAILABILITY NODE       MISE A JOURS AVAILABILITY NODE       */
        /**
         * @description Mise-à-jours des propriété availabitily de chaque node impacté par les nodes défaillant.
         * @param {Object} nodes Nodes à mettre à jours.
         */
        this.majAvailability = function (nodes) {
            var nodes_a_maj = [];
            var node_from_json = getNodeFromJSON(nodes);

            $.each(node_from_json, function () {
                if (this.data.userselected && this.data.availability)
                    nodes_a_maj = nodes_a_maj.concat(getNodesSuccesseurs(this));
                else
                    nodes_a_maj.push(this);

            });

            majAvailability(nodes_a_maj);
        };
        /**
         * @description Mets à jours l'availability des nodes donnés.
         * @param {Array<Object>|Object} nodes
         */
        function majAvailability(nodes) {
            var nodeSuivant = [];

            $.each(nodes, function () {
                if (this.data.userselected !== true) majAvailabilityNode(this);
                if (hasEdgeSuccesseurs(this)) nodeSuivant = nodeSuivant.concat(getNodesSuccesseurs(this));
            });

            if (nodeSuivant.length > 0) {
                if (nodeSuivant.length > 1) nodeSuivant = getArrayWithoutDuplicateValue(nodeSuivant);
                for (var n = nodeSuivant.length - 1; 0 <= n; n--) {
                    if (nodeSuivant[n].data.availability !== undefined) {
                        if (nodeSuivant[n].data.userselected || majAvailabilityNode(nodeSuivant[n], true))
                            nodeSuivant.splice(n, n + 1);
                    }
                }
                majAvailability(nodeSuivant);
            }
        }
        /**
         * @description Mise à jours de la propriété availability du node passé en paramètre.
         * @param {Object} node Node à mettre à jours.
         * @param {Boolean} [just_verify] Permet de faire le processus de calcul de l'availability dans le but de déterminer si oui ou non, celle calculé et celle du node sont la même.
         */
        function majAvailabilityNode(node, just_verify) {
            var xVal = (node.data.redundant === "true" ? {redundantVal: [], otherVal: []} : []);
            /**
             * @description Calcul l'availability.
             * @param {Number} availability Availability du node précédant.
             * @param {Number} criticality Criticality du edge précédant.
             * @returns {Number} Availability du node courant.
             */
            function calculateAvailability(availability, criticality) {
                return 100 - (100 - (availability >= 0 && availability <= 100 ? availability : 100)) * criticality / 100
            }

            var edges_predecesseur = getEdgesPredecesseur(node);
            $.each(edges_predecesseur, function () {
                var node_source = source(this);
                if (node.data.redundant === "true") {
                    if (node_source.data.class === redundantClassOf[node.data.class]) {
                        xVal.redundantVal.push(calculateAvailability(node_source.data.availability, this.data.criticality));
                    } else {
                        xVal.otherVal.push(calculateAvailability(node_source.data.availability, this.data.criticality));
                    }
                } else {
                    xVal.push(calculateAvailability(node_source.data.availability, this.data.criticality));
                }
            });

            if (node.data.redundant === "true") {
                if (!(xVal.redundantVal.length > 0)) xVal.redundantVal.push(100);
                xVal.otherVal.push(Math.max.apply(null, xVal.redundantVal));
                if (just_verify)    return node.data.availability === Math.min.apply(null, xVal.otherVal);
                else                node.data.availability = Math.min.apply(null, xVal.otherVal);
            } else {
                if (just_verify)    return node.data.availability === Math.min.apply(null, xVal);
                else                node.data.availability = Math.min.apply(null, xVal);
            }
        }
        /*      CREATE JSON GROUP BY        CREATE JSON GROUP BY        CREATE JSON GROUP BY        CREATE JSON GROUP BY        CREATE JSON GROUP BY        CREATE JSON GROUP BY        CREATE JSON GROUP BY        CREATE JSON GROUP BY        */
        /**
         * @description Crée le jsonGroupBy selon le groupement donné.
         * @param {String} groupement Le groupement à effectué.
         */
        function createJsonGroupBy(groupement) {
            json[groupement] = {nodes: copyOfJson(json.origine.nodes), edges: copyOfJson(json.origine.edges), groups: []};
            createJsonGroupByLvl(groupement, rootsNode);
        }

        /**
         * @description Crée le jsonGroupBy selon le groupement donné.
         * @param {String} groupement Le groupement à effectué.
         * @param {Array<Object>} nodes Les nodes à grouper.
         */
        function createJsonGroupByLvl(groupement, nodes) {
            var nodeNextLvl = [];
            var lvl = null;

            if (nodes.length > 1) {
                var group = [];
                var nodesGroup = [];

                new IteratorGraph(nodes).forEach(function (node) {
                    if (lvl === null) lvl = node.data.lvl;
                    if (node.data[groupement]) {
                        nodesGroup.push(node);
                        if (group.indexOf(node.data[groupement]) === -1) group.push(node.data[groupement]);
                    }
                });

                /* S'il y a au moin 1 groupe et 2 node. */
                if (group.length > 0 && nodesGroup.length > 1) {
                    for (var index = 0 ; index < group.length ; index++) {
                        var nodesAjouter = [];
                        var groupId = group[index];

                        $.each(nodesGroup, function () {
                            if (this.data[groupement] === group[index]) {
                                nodesAjouter.push(this);
                                /*Ajout du niveau à la fin du groupId pour créer un groupe de niveau.
                                 Mesure de précaution (évite d'avoir un groupe sur plusieurs niveaux).*/
                                if (groupId === group[index]) groupId += "_" + this.data.lvl;
                            }
                        });
                        /* Si l'on a au moins 2 node à ajouté dans le groupe on le cré. */
                        if (nodesAjouter.length > 1) {
                            groupId = groupId.replace(/-/g, "_");
                            /*Remplacement des "-" par des "_". Pour une compatibilité avec GraphViz.
                             groupId "example-de-groupe" sera compris node "example" + edge + node "de" + edge + "groupe" par GraphViz.
                             Dans le dot passé à GraphViz il y aura donc "subgraph cluster_example-de-groupe { ... } et créera une erreur.*/
                            createGroupBy(groupId, nodesAjouter, groupement);
                        }
                    }
                }
            } else if (nodes.length === 1) {
                lvl = nodes[0].data.lvl;
            }

            if (lvl !== null) nodeNextLvl = getNodesNextLvl(lvl);
            if (nodeNextLvl.length > 0) createJsonGroupByLvl(groupement, nodeNextLvl);
        }
        /**
         * @description Crée un group et rassemble les nodes concerné sous son identité.
         * @param {String} groupId L'identifiant du group, (sera l'id du parent)
         * @param {Array<Object>} nodes Les nodes à modifié.
         * @param {String} groupement Le groupement à faire.
         */
        function createGroupBy(groupId, nodes, groupement) {
            var nodeParent = {
                data: {
                    id: groupId,
                    /* On enlève la dernière partie (après le dernier '_') qui correspond au lvl
                     * et on remplace les _ par des tirets. pour le label du group qui sera affiché par cytoscape.*/
                    label: groupId.substring(0, groupId.lastIndexOf("_")).replace(/_/g, "-")
                },
                group: "nodes"
            };

            $.each(nodes, function () {
                this.data.parent = groupId;
                this.data.parents[groupement] = groupId;
            });

            /* On ajoute uniquement le groupe. Les nodes qui le compose sont modifié et n'oublions pas qu'ils sont accessible par référence. */
            json[groupement].groups.push(nodeParent);
        }
        /**
         * @description Mets à jours la propriété 'data.parent' de chaque node en fonction du groupement désiré.
         * @param {String} groupement Le groupement désiré.
         */
        function updateParent(groupement) {
            new IteratorGraph(json.origine.nodes).forEach(function (node) {
                if (node.data.parents[groupement]) node.data.parent = node.data.parents[groupement];
            }, function (percentage) {
                console.log("Updating parents for " + groupement + " grouping. " + percentage + "% completed.");
            });
        }
        /*      FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        FILTRER        */
        /**
         * Filtre selon les labels demandé.
         * Tous les nodes donts les labels ce trouve dans le tableau 'valArray' seront enlevé du graphe finale et remplacé par des edges.
         * @param {Array<String>} valArray
         */
        function filtre(valArray) {
            var nodeToBeFiltered = [];

            /*Récupération des nodes à filtré.*/
            new IteratorGraph(json.origine.nodes).forEach(function (node) {
                if (valArray.indexOf(node.data.class) !== -1) nodeToBeFiltered.push(node);
            });

            filtreNode(nodeToBeFiltered);

            /*S'il y a des groupes, leurs nodes ont peut être tous été filtré donc on va les exclures.*/
            if (json.filtre.groups.length > 0) {
                var groupKo = [];

                $.each(json.filtre.groups, function () {
                    if (!aEncoreAuMoinsUnNode(this.data.id)) groupKo.push(this);
                });

                if (groupKo.length > 0) {
                    $.each(groupKo, function () {
                        json.filtre.groups.slice($.inArray(this, json.filtre.groups), 1);
                    });
                }
            }
        }
        /**
         * @description Remplace les nodes donnés par des edges puis les enlèves ainsi que les edges devenus inutile du json.
         * @param {Array<Object>} nodeToBeFiltered
         */
        function filtreNode(nodeToBeFiltered) {
            new IteratorGraph(nodeToBeFiltered).forEach(function (node) {
                /*L'utilisateur ne peut plus sélectionner ce node car il est filtré et donc n'apparaît plus sur le graphe.*/
                if (node.data.userselected !== true) {
                    /*Récupération des edges prédécesseurs et successeurs.*/
                    var edgesSuccesseurs = getEdgesSuccesseur(node, json.filtre.edges);
                    var edgesPredecesseurs = getEdgesPredecesseur(node, json.filtre.edges);
                    /*S'il y a et des edges prédécesseurs et successeurs, on les enlève et on remplace le node par un edge.*/
                    if (edgesSuccesseurs.length > 0 && edgesPredecesseurs.length > 0) {
                        /*Remplacement du node par tous les edges necessaires.*/
                        for (var es = 0; es < edgesSuccesseurs.length; es++) {
                            for (var ep = 0; ep < edgesPredecesseurs.length; ep++) {
                                /*On crée un edge regroupant les propriétés voulue des deux edges ainsi recuperer*/
                                var edge_remplacement = {
                                    data: {
                                        source: edgesPredecesseurs[ep].data.source,
                                        target: edgesSuccesseurs[es].data.target,
                                        nodes: [node]
                                    }, group: "edges"
                                };
                                /*Si les edges prédécesseurs ou successeurs remplace déjà des nodes, on les ajoutes à la propriété data.nodes de celui fraichement créé.*/
                                if (edgesPredecesseurs[ep].data.nodes) edge_remplacement.data.nodes = edge_remplacement.data.nodes.concat(edgesPredecesseurs[ep].data.nodes);
                                if (edgesSuccesseurs[es].data.nodes) edge_remplacement.data.nodes = edge_remplacement.data.nodes.concat(edgesSuccesseurs[es].data.nodes);

                                json.filtre.edges.push(edge_remplacement);
                            }
                        }
                    }

                    /*Suppression des éléments indésirables de json.filtre*/
                    delete json.filtre.nodes[node.data.id];
                    for (var es = 0; es < edgesSuccesseurs.length; es++)   json.filtre.edges.splice(json.filtre.edges.indexOf(edgesSuccesseurs[es]), 1);
                    for (var ep = 0; ep < edgesPredecesseurs.length; ep++) json.filtre.edges.splice(json.filtre.edges.indexOf(edgesPredecesseurs[ep]), 1);
                }
            }, function (percentage) {
                console.log("Filter node. " + percentage + "% completed.");
            });
        }
        /**
         * @description Dit si le groupe à encore au moins 1 node après filtrage.
         * @param {String} groupId L'identifiant du groupe.
         * @returns {Boolean}
         */
        function aEncoreAuMoinsUnNode(groupId) {
            var lvl = parseInt(groupId.substring(groupId.lastIndexOf("_") + 1));
            var nodesDansLvl = getNodesLvl(lvl, json.filtre);
            var nodesDansGroupe = [];

            $.each(nodesDansLvl, function () {
                if (this.data.parent === groupId) nodesDansGroupe.push(this);
            });

            return nodesDansGroupe.length > 0;
        }

        initJsonElement();
    }

    return ElementJSON;
}());

var Evenements = (function (){ 'use strict'; /** @description Gère tous les évènements du graphe. @param {Graphe} graphe @typedef Evenements Gestionnaire d'évènements de la page html. Fonction avec Graphe. */ function Evenements(graphe) { /** Utilisé pour récupérer, filtré, groupé, etc... les données. @type Graphe */ var graphe_ = graphe; /** Une fois que l'utilisateur finis ses paramétrages, il clique sur le bouton apply et valide tous les changements apporté. Ici nous traitons cette demande. Cette fonction concerne les changements apporté au graphe tant dans le layout que dans les éléments utilisés ainsi que les filtres appliqué. */ function grapheActions() { $("#graphe_action__button").click(function () { var layout = JSON.parse($("#layout-select").val()); changeGrapheElement($(document.querySelectorAll("input[name=\"group\"]:checked")).val()); if ($(document.querySelectorAll("input[name=\"activate_deactivate_classesfilter\"]:checked")).val() === "on") { filterGrapheElement(); } else { graphe_.filtrerEnd(); } if (layout.type === "cyto") { changeCytoLayout(layout); } else { changeVizLayout(layout); } graphe_.run(); }); } /** Filtre les éléments du graphe selon la sélection utilisateur. */ function filterGrapheElement() { if ($(".nodeclass:checked").length > 0) { var filtre_tab = getLabelFiltre(); if (filtre_tab.length > 0) graphe_.filtrer(filtre_tab); else graphe_.filtrerEnd(); } } /** Membre priver - Donne les valeur sélectionner pour les différentes checkbox de filtrage. @returns {Array<String>} */ function getLabelFiltre() { var valArray = []; $.each($("#filters_classes .nodeclass"), function (index, valeur) { if (!valeur.checked) valArray.push(valeur.value); }); return valArray; } /** Récupère le groupe voulue et le mets sous la bonne forme pour graphe. @param {String} groupe_wanted */ function changeGrapheElement(groupe_wanted) { switch (groupe_wanted) { case "nogroup": groupe_wanted = utilisation.origine; break; case "groupbycause": groupe_wanted = utilisation.cause; break; case "groupbyimpact": groupe_wanted = utilisation.impact; break; default: groupe_wanted = ""; break; } graphe_.changeElement(groupe_wanted); } /** @description Changement de layout spécifique à un changementGrapgViz. @param {Object} layout */ function changeVizLayout(layout) { layout.direction = $(document.querySelectorAll("input[name=\"viz_orientation\"]:checked")).val(); graphe_.changeLayout(layout); } /** @description Changement de layout spécifique à un layout cytoscape. @param {Object} layout */ function changeCytoLayout(layout) { graphe_.changeLayout(layout); } /** @description Gestion du redimensionnement de lafenetre. */ function redimensionnement() { $(window).resize(function () { graphe_.redimensionnement(); }); } /** @description Lance l'initialisation de tous les évènement cytoscape. */ function cytoscapeEvent() { var cytoscape = graphe_.getCy(); selectionNode(cytoscape); deselectionNode(cytoscape); } /** @description Gestion de la selection d'un node par l'utilisateur. Changement graphique pour une meilleur vision du node et ce qui y est lié. @param {Object} cytoscape Correspond à une instance de Cytoscape */ function selectionNode(cytoscape) { cytoscape.on('select', 'node:child, node:orphan', function (e) { var node_selectionne = cytoscape.nodes(":selected"); node_selectionne.forEach(function (node) { node.data("availability", 0); node.data.availability = 0; node.data("userselected", true); node.data.userselected = true; }); node_selectionne.successors("node").difference(node_selectionne).removeData("availability"); if (!node_selectionne.outgoers("node").empty()) { graphe_.majAvailability(node_selectionne); } graphe_.majGraphColor(); }); cytoscape.on('select', '$node > node', function (e) { e.cyTarget.children().select(); }); } /** @description Lors de la désélection d'un node, il faut le faire repassé à l'état initiale ainsi que tous ses impacts. @param {Object} cytoscape Correspond à une instance de Cytoscape */ function deselectionNode(cytoscape) { cytoscape.on('unselect', 'node:child, node:orphan', function (e) { var node = e.cyTarget; node.successors().add(node).removeData("availability"); delete node.data.availability; node.removeData("userselected"); delete node.data.userselected; if (graphe_.estRoot(node)) { node.data("availability", 100); node.data.availability = 100; } graphe_.majAvailability(node); graphe_.majGraphColor(); }); } /** @description Initialisation des évènement cytoscape. */ this.initEventCy = function () { initEventCy(); }; /** @description Initialisation des évènement cytoscape. */ function initEventCy() { cytoscapeEvent(); } /** @description Cette fonction permet de : - Centrer le graphe ou les elements selectionner, - Zommer sur le graphe ou les élément sélectionner. */ function fit_center_event() { $("#fit_or_center_apply_button").click(function () { fit_center(document.querySelector("#fit_or_center input[name=\"fitorcenterchoice\"]:checked").value, document.querySelector("#fit_or_center input[name=\"fitorcenterto\"]:checked").value === "true"); }); $("#fit_center_button").click(function () { fit_center(document.querySelector("#fit_or_center input[name=\"fitorcenterchoice\"]:checked").value, document.querySelector("#fit_or_center input[name=\"fitorcenterto\"]:checked").value === "true"); }); } /** @description Permet de centrer ou de centrer et zoomé/dézoomé sur le graphe ou les nodes sélectionné. @param {String} fonction La fonction à employé (fit()|center()) @param {Boolean} selected Sur quels éléments (true = nodes sélectionnés ; false = graphe) */ function fit_center(fonction, selected) { var element_to = (selected && graphe_.getCy().nodes(":selected").size() > 0 ? graphe_.getCy().nodes(":selected") : {}); switch (fonction) { case "center": graphe_.getCy().center(element_to, 30); break; case "fit": graphe_.getCy().fit(element_to, 30); break; } } /** @description Permet de faire une nouvelle requête sur les nodes sélectionnés. */ function newRequestEvent() { $("#new_graph_request").click(function () { var selectedNodes = graphe_.getCy().nodes(":selected"); if (selectedNodes.size() > 0) newRequestWithSelectedNodes(selectedNodes); }); } /** @description Fait une redirection de la page html pour soumettre une nouvelle requête à lavoisier sur les nodes sélectionnés. @param {Object} nodes Nodes sélectionnés. */ function newRequestWithSelectedNodes(nodes) { var baseUrl = racineUrl + "lavoisier/impact"; var params = {Key: "id", Value: ""}; var values = []; for (var n = 0; n < nodes.size(); n++) { values.push(nodes[n].id()); } params.Value = values.join('|'); window.location.href = baseUrl + "?Key=" + params.Key + "&Value=" + params.Value; } initEventCy(); grapheActions(); redimensionnement(); fit_center_event(); newRequestEvent(); } return Evenements; }());

var Graphe = (function () { 'use strict'; /** @description Utilise cytoscape pour fournir un graphe. Gère les changements de layout prévu pour cytoscape et les différentes classes de couleurs pour les impacts, causes et unknown. @param {ElementJSON} element_json @typedef Graphe Gère le graphe en utilisant cytoscape. Fait le lien entre ElementJSON et cytoscape. */ function Graphe(element_json) { /** Paramètre pour les différents layout utilisés. @type Object Layout paramètre */ var param = { /*Paramètre pour le layout COLA.JS*/ cola: { name: "cola", nodeSpacing: 8, edgelength: 60, padding: 30, alignment: function (node) { return {x: 260 * (node.data("lvl") - 1)}; }, animate: true}, /*Paramètre pour le layout BREADTHFIRST*/ breadthfirst: { name: "breadthfirst", padding: 30, animate: true, animationDuration: 650, roots: [], directed: true}, /*Paramètre pour les autres layouts (GRID,  [CIRCLE], CONECNTRIC)*/ autre: { name: "", padding: 30, animate: true, animationDuration: 650} }; /** Paramètre pour le layout Cola.js @type {{name:String, alignment:Function, animate:Boolean,maxSimulationTime:Number}} Cola Layout Parameters */ var cola = { /*name : "preset",*/ name: "cola", alignment: function (node) { return {x: node.position.x, y: node.position.y}; }, /*positions:function(node) { return {x : node.data('personnalPosition').x, y : node.data('personnalPosition').y} ; },*/ animate: true, /*animationDuration : 1000*/ maxSimulationTime: 1000}; /** Style cytoscape sous format JSON. @type Object Styles for Cytoscape */ var style_cytoscape; /** Gestionnaire d'événement du graphe. @type Evenements */ var event; /** Graphe cytoscape. @type Cytoscape */ var cy; /** Garde les menus contextuelle. @type Array */ var context = []; /** @description Gestion du layout de cytoscape. @type Cytoscape layout */ var cy_layout; /** Contient les informations relatif au layout : - type, le type de layout "cyto"|"viz"; - nom, le nom du layout "circo"|"circle", - isrunning, dit si le layout à démarré. @typedef {{type:String, nom:String, isrunning:Boolean}} StructureLayout Structure d'un layout */ var layout = {type: "", nom: "", isrunning: false}; /** Permet de récupérer les éléments JSON originellement donnée via XML. @returns {Array<Object>} */ this.getElementOrigine = function () { return element_json.getElementOrigine(); }; /** Permet de récupérer les 'class', information donnée comme donnée de type 'data' à tous les éléments. @returns {Array<String>} */ this.getClasses = function () { return element_json.getClasses(); }; /** Définis le gestionnaire d'événements du Graphe. @param {Evenements} evenement @see Evenements */ this.setEvent = function (evenement) { event = evenement; }; /** Permet d'accéder à l'élément de type Cytoscape et d'accéder à toutes ses fonctionnalités. @returns {Cytoscape|Graphe.cy} */ this.getCy = function () { return cy; }; /** @description Fonction de modification du tableau elements de cytoscape. @param {Array<Object>} json */ this.setCytoscapeElement = function (json) { setCytoscapeElement(json); }; /** @description Fonction de modification du tableau elements de cytoscape. @param {Array<Object>} json */ function setCytoscapeElement(json) { cy.off('select'); cy.off('unselect'); cy = cytoscape({ container: $("#cy"), elements: json, style: style_cytoscape, maxZoom: 6 }); initLabelNodes(); initBreadthfirstRoot(); if (context.length > 0) { for (var key in context) { addContextMenu(context[key]); } } /*On mets à jours le temps d'animation du layout cytoscape IMPORTANT : Plus il y a d'éléments, plus le temps d'animation sera conséquent.*/ initColaTime(); event.initEventCy(); /* S'il y a des nodes précédemment sélectionner, on les sélectionne. */ if (cy.nodes("[userselected]").size() > 0) { cy.nodes("[userselected]").select(); } else { majGraphColor(); } } /** Définis les label utilisé pour chaque node. */ function initLabelNodes() { cy.batch(function () { cy.nodes().forEach(function (node) { if (!node.isParent()) node.style("label", node.data("description") + '\n' + node.data("class")); }); }); } /** Pour le layout breadthfirst, spécifie les nodes roots ddans param.breadthfirst.roots */ function initBreadthfirstRoot() { param.breadthfirst.roots = cy.nodes().roots(); } /** Initialisation du temps maximum de simulation du layout 'cola.js' */ function initColaTime() { var nbrElement = cy.nodes().size(); param.cola.maxSimulationTime = nbrElement * 10; } /** @description Mise-à-jours des propriété availabitily de chaque node impacté par les nodes sélectionné. @param {Object} nodes Nodes à mettre à jours. */ this.majAvailability = function (nodes) { element_json.majAvailability(nodes); }; /** @description Mise-à-jours des propriété availabitily de chaque node impacté par les nodes sélectionné. @param {Object} nodes Nodes à mettre à jours. */ function majAvailability(nodes) { element_json.majAvailability(nodes); } /** Dit si le node est root. @param {Object} node @returns {Boolean} */ this.estRoot = function (node) { return node.anySame(cy.nodes().roots()); }; /** Demande le redimensionnement du graphe. @argument {String} type "center" | "fit" @argument {String} selected "true" | "false" */ this.redimensionnement = function (type, selected) { if (typeof type === "undefined") { cy.fit({}, 30); } else { var selectionne = {}; if (selected === "true") { selectionne = cy.elements(":selected"); } switch (type) { case "fit": cy.fit(selectionne, 30); break; case "center": cy.center(selectionne); break; } } }; /** Mets à jours les couleur du graphe. */ this.majGraphColor = function () { majGraphColor(); }; /** Mets à jours les couleur du graphe. */ function majGraphColor() { cy.batch(function () { resetAllColor(); cy.nodes().addClass("external"); if (!cy.nodes(":selected").empty()) { var causes = cy.nodes(":selected").predecessors().addClass("cause").removeClass("external"); var impacts = cy.nodes(":selected").add(cy.nodes(":selected").successors()).addClass("impacter").removeClass("external"); causes.intersection(impacts).removeClass("cause"); verifIntersectedPredecessorsNode(); } majNodeColor(); majEdgeColor(); }); } /** Vérifie s'il y a des node qui sont predecesseurs de plusieurs nodes défaillant et les mets en avant. */ function verifIntersectedPredecessorsNode() { cy.batch(function () { var allPredecessorsCollection = []; cy.nodes(":selected").forEach(function (node) { allPredecessorsCollection[allPredecessorsCollection.length] = node.predecessors("node:child, node:orphan").difference(node); }); var intersectionPredecessor = []; for (var i = 0; i < allPredecessorsCollection.length - 1; i++) { for (var j = i + 1; j < allPredecessorsCollection.length; j++) { /*Récupération d'une collection de tous les nodes qui sont intersections des deux collections.*/ intersectionPredecessor[intersectionPredecessor.length] = allPredecessorsCollection[i].intersection(allPredecessorsCollection[j]); } } for (var n = 0; n < intersectionPredecessor.length; n++) { intersectionPredecessor[n].forEach(function (node) { node.addClass("intersection"); }); } }); } /** Mise à jours de la couleur de tous les nodes */ function majNodeColor() { cy.nodes(":child, :orphan").difference("node:parent").forEach(function (node) { if (node.hasClass("impacter")) { node.addClass(getClassCouleur(node.data("availability"))); } }); } /** Mise à jour de la couleur de tous les edges. */ function majEdgeColor() { cy.edges().forEach(function (edge) { if (edge.source().hasClass("impacter")) { var classCouleur; if (typeof edge.data("nodes") !== "undefined") { var edgeAvailability; if (edge.data("nodes").length > 1) { var xVal = []; $.each(edge.data("nodes"), function () { xVal.push(this.data.availability); }); edgeAvailability = Math.min.apply(null, xVal); } else { edgeAvailability = edge.data("nodes")[0].data.availability; } classCouleur = getClassCouleur(edgeAvailability); } else { classCouleur = getClassCouleur(edge.source().data("availability")); } edge.addClass(classCouleur); } }); } /** Mise à zéro de toutes les couleurs. */ function resetAllColor() { cy.elements("*").forEach(function (element) { removeAllClasses(element); }); } /** Enlève toutes les classes de mise en couleur que peut avoir l'élément. @param {Object} element */ function removeAllClasses(element) { /*Suppression de toutes les classes de coloration de l'élément.*/ element.removeClass("rouge rouge_orange orange orange_jaune jaune jaune_vert vert impacter cause intersection external"); } /** Lance le spécifié. Si aucun layout n'est spécifié, lance le layout par défaut (cola.js). */ this.run = function () { if (!layout.isrunning) { if (layout.type === "cyto") { runCyto(); } else if (layout.type === "viz") { runViz(); } else { console.log("Layout inconnu."); } layout.isrunning = true; } }; /** Démarre le layout en considérant un layout de Cytoscape préalablement demandé par l'utilisateur. */ function runCyto() { var paramToUse = ""; switch (layout.nom) { case param.cola.name: paramToUse = layout.nom; break; case param.breadthfirst.name: paramToUse = layout.nom; break; default: paramToUse = "autre"; param[paramToUse].name = layout.nom; break; } cy_layout = cy.makeLayout(param[paramToUse]); cy_layout.run(); } /** Démarre le layout en considérant un layout de GraphViz préalablement demandé par l'utilisateur. */ function runViz() { $("#cy").html(""); $("#cy").addClass("computing"); setTimeout(function () { setCytoscapeElement(element_json.runViz()); cy_layout = cy.makeLayout(cola); $("#cy").removeClass("computing"); cy_layout.run(); }, 150); } /** Changement de layout demandé par l'utilisateur. @param {StructureLayout} layout_selected */ this.changeLayout = function (layout_selected) { if (layout_selected.type === "cyto") { changeLayoutCyto(layout_selected); } else { changeLayoutViz(layout_selected); } }; /** Changement de layout cytoscape. @param {StructureLayout} layout_selected */ function changeLayoutCyto(layout_selected) { if (layout_selected.type !== layout.type || layout_selected.nom !== layout.nom) { layout.type = layout_selected.type; layout.nom = layout_selected.nom; layout.isrunning = false; } } /** Changement de layout GraphViz. @param {StructureLayout} layout_selected */ function changeLayoutViz(layout_selected) { var viz_layout = element_json.getVizLayout(); if (layout_selected.nom !== viz_layout.nom || layout_selected.direction !== viz_layout.direction || layout.type !== layout_selected.type) { if (layout_selected.nom !== viz_layout.nom) element_json.changeVizEngine(layout_selected.nom); if (layout_selected.direction !== viz_layout.direction) element_json.changeVizDirection(layout_selected.direction); layout.type = layout_selected.type; layout.nom = layout_selected.nom; layout.isrunning = false; } } /** Modifie les éléments du graphe en fonction de la demande utilisateur. @param {utilisation} groupe_wanted Enumération utilisation @see utilitaire.js */ this.changeElement = function (groupe_wanted) { if (groupe_wanted !== element_json.getUsed()) { setCytoscapeElement(element_json.getElementFor(groupe_wanted)); layout.isrunning = false; } }; /** @public @description Change l'orientation du graphe viz. Utilisable uniquement pour les layouts basés sur viz.js @param {String} wanted_direction */ this.changeVizDirection = function (wanted_direction) { element_json.changeVizDirection(wanted_direction); }; /** Ajout d'un menu contextuel sur le clic droit de la souris. @param {Object} menu CytoscapeContext */ this.addContextMenu = function (menu) { context[context.length] = menu; addContextMenu(menu); }; /** Ajout d'un menu contextuel sur le clic droit de la souris. @param {Object} menu CytoscapeContext */ function addContextMenu(menu) { cy.cxtmenu(menu); } /** Filtre le graph en fonction des valeur donné. @param {Array} valArray */ this.filtrer = function (valArray) { setCytoscapeElement(element_json.getFilteredElement(valArray)); layout.isrunning = false; }; /** Mets fin au filtre et réaffiche tous les éléments. */ this.filtrerEnd = function () { if (element_json.isFilterJson()) { setCytoscapeElement(element_json.getUsedJson()); layout.isrunning = false; } }; style_cytoscape = styles_cytoscape; cy = cytoscape({ container: $("#cy"), elements: element_json.getElementOrigine(), style: style_cytoscape, maxZoom: 6}); initLabelNodes(); initBreadthfirstRoot(); initColaTime(); event = new Evenements(this); /* S'il y a des nodes dont l'attribut 'selectionner' a pour valeur 'selected' il faut les sélectionner. */ cy.nodes("[selectionner]").select(); } return Graphe; }());